// ****************************************************************
// Beispiel Stimulus-Datei
// ****************************************************************

`timescale 1ns / 10ps

// Schnittstelle f"ur Standardtestrahmen
module stimulus (
                 // Schnittstellensignale PPC Master <-> PLB On-Chip-Bus
                 PLBC405DCUADDRACK,
                 PLBC405DCUBUSY,
                 PLBC405DCUERR,
                 PLBC405DCURDDACK,
                 PLBC405DCURDDBUS,
                 PLBC405DCURDWDADDR,
                 PLBC405DCUSSIZE1,
                 PLBC405DCUWRDACK,
                 PLBC405ICUADDRACK,
                 PLBC405ICUBUSY,
                 PLBC405ICUERR,
                 PLBC405ICURDDACK,
                 PLBC405ICURDDBUS,
                 PLBC405ICURDWDADDR,
                 PLBC405ICUSSIZE1,
                 PLBCLK,
                 C405PLBDCUABORT,
                 C405PLBDCUABUS,
                 C405PLBDCUBE,
                 C405PLBDCUCACHEABLE,
                 C405PLBDCUGUARDED,
                 C405PLBDCUPRIORITY,
                 C405PLBDCUREQUEST,
                 C405PLBDCURNW,
                 C405PLBDCUSIZE2,
                 C405PLBDCUU0ATTR,
                 C405PLBDCUWRDBUS,
                 C405PLBDCUWRITETHRU,
                 C405PLBICUABORT,
                 C405PLBICUABUS,
                 C405PLBICUCACHEABLE,
                 C405PLBICUPRIORITY,
                 C405PLBICUREQUEST,
                 C405PLBICUSIZE,
                 C405PLBICUU0ATTR,
                 EICC405EXTINPUTIRQ
                );

// Bibliothek von Hilfsfunktionen lesen
`include "plbutils.v"

  // Hier beginnt der eigentliche Test
  initial begin : test

    // Hilfsvariable als Ziel f"ur Leseoperationen
    reg [31:0] data;

    // Initialisiere Simulationsumgebung
    Startup;

    // F"uhre einen systemweiten Reset durch
    SystemReset;

    // Starte Aufzeichnung der Signalzustaende
    StartRecordingSignals;

    // Lese ein 32b Wort von der Adresse 0
    Read32(`SLAVE_BASE + 24'h0, data);
    $display("Register 0: %h\n", data);

    // Schreibe einen Wert in Adresse 0
    Write32(`SLAVE_BASE + 24'h0, 32'h87654321);

    // Lese den neuen Inhalt des Registers
    Read32(`SLAVE_BASE + 24'h0, data);
    $display("Register 0: %h\n", data);

    // Laufe f"ur 10 Takte
    RunFor(10);

    // Fahre Simulationsumgebung wieder herunter
    Shutdown;
  end

endmodule
